#	Masrv
#	Copyright (C) 2007 Michal Vaner (vorner@ucw.cz)
#
#	This program is free software; you can redistribute it and/or modify
#	it under the terms of the GNU General Public License as published by
#	he Free Software Foundation; either version 2 of the License, or
#	(at your option) any later version.
#
#	This program is distributed in the hope that it will be useful,
#	but WITHOUT ANY WARRANTY; without even the implied warranty of
#	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#
#	GNU General Public License for more details.
#
#	You should have received a copy of the GNU General Public License
#	along with this program; if not, write to the Free Software
#	Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

import socket
import config
import glob
import selector
import client

class listener:
	def __init__( self, images, manager ):
		glob.info( "Creating the server socket" )
		af = socket.AF_INET
		defaddr = "0.0.0.0"
		if socket.has_ipv6 and not ( config.data.get( "supress_ipv6", False ) == "True" ):
			af = socket.AF_INET6
			defaddr = "::0"

		self.__socket = socket.socket( af )
		bindaddr = ( config.data.get( "bindaddr", defaddr ), int( config.data.get( "port", 1056 ) ) )
		glob.info( "Binding to " + str( bindaddr ) )
		self.__socket.bind( bindaddr )
		self.__socket.listen( 5 )
		self.__images = images
		self.__manager = manager

	def fileno( self ):
		return self.__socket.fileno()

	def read( self ):
		glob.info( "Accepting a new connection" )
		( sock, addr ) = self.__socket.accept()
		glob.info( "Address is " + str( addr ) )
		selector.insert( client.client( sock, addr, self.__images, self.__manager ) )

	def wantWrite( self ):
		return False
