#	Masrv
#	Copyright (C) 2007 Michal Vaner (vorner@ucw.cz)
#
#	This program is free software; you can redistribute it and/or modify
#	it under the terms of the GNU General Public License as published by
#	he Free Software Foundation; either version 2 of the License, or
#	(at your option) any later version.
#
#	This program is distributed in the hope that it will be useful,
#	but WITHOUT ANY WARRANTY; without even the implied warranty of
#	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#
#	GNU General Public License for more details.
#
#	You should have received a copy of the GNU General Public License
#	along with this program; if not, write to the Free Software
#	Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

import glob
import select

items = []
periodics = []

def insert( item ):
	glob.info( "Inserting item " + str( item ) )
	global items
	items.append( item )

def run():
	global items
	global periodics
	while True:
		( reads, writes, errors ) = select.select( items, filter( lambda x: x.wantWrite(), items ), items, 0.1 )
		for obj in errors:
			glob.warn( "Error on socketoid, dropping" )
			try:
				obj.err()
			except AttributeError:
				pass#Ignore if the err is not defined for the object
			try:
				items.remove( obj )
			except ValueError:
				pass #Not there already

		for obj in reads:
			obj.read()

		for obj in writes:
			obj.performWrite()

		timestamp = glob.timestamp()
		for obj in periodics:
			obj.tick( timestamp )

def remove( item ):
	glob.info( "Removing item " + str( item ) )
	global items
	try:
		items.remove( item )
	except ValueError:
		pass #Not there already

def insertPeriodic( item ):
	glob.info( "Inserting periodic object " + str( item ) )
	global periodics
	periodics.append( item )

def removePeriodic( item ):
	glob.info( "Removing periodic object " + str( item ) )
	global periodics
	periodics.remove( item )
